#include "main.h"

#define MAX_ENEMY (32)
#define ENEMY_HISTORY_LENGTH (16)

typedef struct
{
	xy position;
	int moves;
	Direction direction;
	int active;
	int id;
	xy history[ENEMY_HISTORY_LENGTH];
	int historypos;
} Enemy;

Enemy enemies[MAX_ENEMY];

int even=1;

void initenemies()
{
	int i;
	for(i=0; i<MAX_ENEMY; i++)
	{
		enemies[i].active = 0;
	}
}

void updateenemy(Enemy *enemy)
{
	if(!enemy->active)
		return;
	if(enemy->id == 1 && !even)
		return;
	int check;
	switch(enemy->direction)
	{
		case DIR_NORTH: 
			enemy->position.y--;
			check=0;
			break;
		case DIR_EAST: 
			enemy->position.x++;
			check=1;
			break;
		case DIR_SOUTH:
			enemy->position.y++;
			check=2;
			break;		
		case DIR_WEST:
			enemy->position.x--;
			check=3;
			break;		
		default: break;
	}
	enemy->history[enemy->historypos] = enemy->position;
	enemy->historypos = (enemy->historypos+1)%ENEMY_HISTORY_LENGTH;
	enemy->moves--;
	if(!enemy->moves)
	{
		int dirpref[4];
		enemy->moves = 16;
		Direction validdirs = getdirs(enemy->position.x, enemy->position.y);
		Direction olddir = enemy->direction;
		int i, j;
		int xdist = enemy->position.x - playerpos.x;
		int ydist = enemy->position.y - playerpos.y;
		dirpref[0] = enemy->direction == DIR_SOUTH ? -1000 : ydist;
		dirpref[1] = enemy->direction == DIR_WEST ? -1000 :-xdist;
		dirpref[2] = enemy->direction == DIR_NORTH ? -1000 :-ydist;
		dirpref[3] = enemy->direction == DIR_EAST ? -1000 :xdist;	
				
		if(enemy->id==0)
			dirpref[check] = 1000;
		else if(enemy->id==2)
			dirpref[check] = -900;
			
		for(j=0; j<4; j++)
		{
			int id;
			int max = -5000;
			Direction check;
			for(i=0; i<4; i++)
			{
				if(dirpref[i] > max)
				{
					id=i;
					max = dirpref[i];
				}
			}
			switch(id)
			{
				case 0: check = DIR_NORTH; break;
				case 1: check = DIR_EAST; break;
				case 2: check = DIR_SOUTH; break;
				case 3: check = DIR_WEST; break;
			}
			if(validdirs & check)
			{
				enemy->direction = check;				
				break;
			}
			dirpref[id] = -5000;		
		}
		if(enemy->direction != olddir)
			playsound(SOUND_BLIP1+enemy->id);
	}
}

void updateenemies()
{
	even = !even;
	int i;
	for(i=0; i<MAX_ENEMY; i++)
		updateenemy(&enemies[i]);	
}

void drawenemies()
{
	int i;
	for(i=0; i<MAX_ENEMY; i++)
		if(enemies[i].active)
		{
			Sprite sprite;
			switch(enemies[i].id)
			{
				case 0: sprite = SPRITE_BLOBB; break;
				case 1: sprite = SPRITE_BLOBC; break;
				case 2: sprite = SPRITE_BLOBD; break;
			}
			int j;
			for(j=0; j<8; j++)
			{
				int historyindex = enemies[i].historypos - (j+1);
				while(historyindex < 0)
					historyindex += ENEMY_HISTORY_LENGTH;
				setcol4(1,1,1,(0.2*(8-i))/8);
				drawsprite(sprite, enemies[i].history[historyindex].x, enemies[i].history[historyindex].y);
			}
			setcol4(1,1,1,1);
			drawsprite(sprite, enemies[i].position.x, enemies[i].position.y);
		}
}

void spawnenemy(int x, int y, int id)
{
	int i;
	int j;
	for(i=0; i<MAX_ENEMY; i++)
	{
		if(!enemies[i].active)
		{
			enemies[i].position.x = x;
			enemies[i].position.y = y;
			enemies[i].moves = SPRITE_SIZE;
			enemies[i].direction = DIR_NORTH;
			enemies[i].active = 1;
			enemies[i].id = id;
			for(j=0; j<ENEMY_HISTORY_LENGTH; j++)
			{
				enemies[i].history[j].x = -64;
				enemies[i].history[j].y = -64;
			}	
			enemies[i].historypos = 0;			
			return;
		}
	}
}

int checkhurt(int x, int y)
{
	int i;
	for(i=0; i<MAX_ENEMY; i++)
	{
		if(!enemies[i].active)
			continue;
		int xdist = enemies[i].position.x - x;
		int ydist = enemies[i].position.y - y;
		xdist *= xdist;
		ydist *= ydist;
		if(ydist < 64 && xdist < 64)
		{
			return 1;
		}
	}
	return 0;
}
