#include "main.h"
#include <SDL/SDL_mixer.h>

Mix_Music *music;
Mix_Chunk *samples[SOUND_MAX];
int playsounds = 1;
int musicplaying = 0;

char soundnames[SOUND_MAX][32] =
{
	"sfx\\blip0.wav",
	"sfx\\blip1.wav",
	"sfx\\blip2.wav",
	"sfx\\blip3.wav",
	"sfx\\collectman.wav",
	"sfx\\rescueman.wav",
	"sfx\\playerhurt.wav",
	"sfx\\manhurt.wav",
	"sfx\\win.wav",
};

int timeout[SOUND_MAX];

void soundinit()
{
	int i;
    Mix_OpenAudio(22050, MIX_DEFAULT_FORMAT, 2, 256);
    //music=Mix_LoadMUS("sound/foo.ogg");
	for(i=0; i<SOUND_MAX; i++)
	{
		samples[i] = Mix_LoadWAV(soundnames[i]);
		timeout[i] = 0;
	}
}

void updatesound()
{
	int i;
	for(i=0; i<SOUND_MAX; i++)
		if(timeout[i])
			timeout[i]--;
}

void sounddeinit()
{
	int i;
    Mix_CloseAudio();
    for(i=0; i<SOUND_MAX; i++)
		Mix_FreeChunk(samples[i]);
}

void playmusic()
{
	Mix_PlayMusic(music, -1);
	musicplaying = 1;
}

void stopmusic()
{
	Mix_FadeOutMusic(500);
	musicplaying = 0;
}

void playsound(Sound sound)
{
	if(playsounds && !timeout[sound])
	{
		Mix_PlayChannel(-1, samples[sound], 0);
		timeout[sound] = 15;
	}
}

void togglesounds()
{
	playsounds = !playsounds;
}

void togglemusic()
{
	if(musicplaying)
		stopmusic();
	else
		playmusic();
}

void mute(int on)
{
	Mix_VolumeMusic(on ? 0 : MIX_MAX_VOLUME);
}
